#include <cstdio>
#include <vector>
#include "memory.h"
using namespace std;

vector<int> A, L;
vector<int> C[110][110];

void NullC(){
    for(int i = 0; i < 105; i++) for(int j = 0; j < 105; j++) C[i][j].clear();
}

void out(vector<int> x){
    for(int i=x.size()-1; i > -1; i--) printf("%d", x[i]);
    printf("\n");
}

vector<int> Mult(const vector<int> & a, int b){
    vector<int> c = a;
    if(b == 0) {
        c.assign(1, 0);
        return c;
    }

    for(int i = 0; i < c.size(); i++) c[i] *= b;
    for(int i = 0; i < c.size()-1; i++) {
        c[i+1] += c[i]/10;
        c[i] %= 10;
    }
    while(c.back()>9) {
        c.push_back(c.back()/10);
        c[c.size()-2] %= 10;
    }
    return c;
}

vector<int> Add(const vector<int> & a, const vector<int> & b){
    vector<int> c = a;
    for(int i = 0; i < b.size(); i++){
        if(i >= c.size()) c.push_back(b[i]);
        else c[i] = c[i] + b[i];
    }
    for(int i = 0; i < c.size()-1; i++) {
        c[i+1] += c[i]/10;
        c[i] %= 10;
    }
    while(c.back()>9) {
        c.push_back(c.back()/10);
        c[c.size()-2] %= 10;
    }
    return c;
}

void Cbuild(){
    for(int i = 0; i < 105; i++) C[i][0].push_back(1);
    for(int i = 1; i < 105; i++){
        for(int j = 1; j < i; j++) C[i][j] = Add(C[i-1][j], C[i-1][j-1]);
        C[i][i].push_back(1);
    }
}

vector<int> nep(int t, int Nt){
    vector<int> ans; ans.assign(1,0);
    vector<int> ans1, ans2; ans2.assign(1, 1);
    for(int i = 1; i <= Nt/2; i++) {
        ans1 = C[Nt][2*i];
        for(int ii = 1; ii <= 2*i-1; ii+=2) ans1 = Mult(Mult(ans1, ii), t);
        //ans1 = Add(ans1, ans2);
        ans = Add(ans, ans1);
    }
    ans = Add(ans, ans2);
    return ans;

}

vector<int> parn(int t, int Nt){
    vector<int> ans; ans.assign(1, 1);
    for(int i = 1; i <= Nt/2; i++){
        ans = Mult(Mult(ans, t), i*2-1);
    }
    return ans;
}

vector<int> Multt(const vector<int> & a, const vector<int> & b){
    vector<int> c, ans; ans.assign(1,0);
    vector<int> cc;
    ans = Mult(a, b[0]);
    for(int i = 1; i < b.size(); i++){
        c = Mult(a, b[i]);
        cc.assign(i, 0);
        c.insert(c.begin(), cc.begin(), cc.end());
        ans = Add(ans, c);
    }
    return ans;
}

int main(){
    vector<int> kk(3, 2);
    vector<int> pk(6,3);
    Cbuild();
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);
    int n;
    scanf("%d", &n);
    A.resize(n);
    for(int i = 0; i < n; i++) {scanf("%d", &A[i]); A[i]--;}

    L.resize(n+2);
    int k, t, tt;
    for(int i = 0; i < n; i++) if(A[i] > -1){
        k = 0;
        t = A[i];
        tt = i;
        while(A[tt] > -1) { k++; A[tt] = -1; tt = t; t = A[tt]; }
        L[k]++;
    }

    //for(int i = 0; i < n; i++) if(L[i]>0) {printf("%d %d\n", i, L[i]);}
    for(int i = 0; i < n; i+=2) if(L[i]&1) {
        printf("0");
        return 0;
    }

    vector<int> ans;
    ans.assign(1,1);

    for(int i = 1; i < n+1; i++) if(L[i] > 0) {
        if(i&1) ans = Multt(ans, nep(i, L[i]));
        else ans = Multt(ans, parn(i, L[i]));
        //out(ans);
    }

    out(ans);

    fclose(stdin);
    fclose(stdout);
    return 0;
}
