/* GCC */
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define fast ios_base::sync_with_stdio(false); cin.tie(false); cout.tie(false)
#define file(s) freopen(s ".in","r",stdin); freopen(s ".out","w",stdout)
#define end '\n'
#define FilkinMaksim int main()

const long long mod = 1e9;

typedef vector <long long> tlong;

tlong operator * (const tlong &a, const tlong &b){
    tlong ans;
    ans.assign(a.size() + b.size(),0);
    for (int i = 0; i < a.size(); i++)
        for (int j = 0, cur = 0; j < b.size() || cur; j++){
            long long t = ans[i+j] + cur + a[i] * (j < b.size() ? b[j] : 0);
            ans[i+j] = t % mod;
            cur = t / mod;
        }
    while (ans.size() > 1 && ans.back() == 0) ans.pop_back();
    return ans;
}

tlong operator + (const tlong &a, const tlong &b){
    tlong ans;
    long long t = 0;
    for (int i = 0; i < max(a.size(),b.size()) || t; i++){
        t += (i < a.size() ? a[i] : 0) + (i < b.size() ? b[i] : 0);
        ans.push_back(t % mod);
        t /= mod;
    }
    return ans;
}

void write(const tlong &a){
    printf("%d",a[a.size()-1]);
    for (int i = a.size() - 2; i > -1; i--)
            printf("%09d",a[i]);
    printf("\n");
}

tlong dp[110][110];

tlong cnk (long long n, long long k){
    if (!dp[n][k].empty()) return dp[n][k];
    if (k == 0 || k == n) return dp[n][k] = tlong(1,1);
    return dp[n][k] = cnk(n-1,k-1) + cnk(n-1,k);
}

tlong fac(long long kol, long long k){
    tlong ans;
    ans.push_back(1);
    for (long long i = 0; i < kol / 2; i++)
        ans = ans * tlong(1,k);
    for (long long i = kol - 1; i > 0; i-=2)
        ans = ans * tlong(1,i);
    return ans;
}

tlong fac1(long long kol, long long k){
    tlong ans;
    ans.push_back(0);
    for (long long i = 1; i <= kol / 2; i++){
        tlong yuh;
        yuh.push_back(1);
        for (long long j = 0; j < i; j++)
            yuh = yuh * tlong(1,k);
        for (long long j = 2*i - 1; j > 0; j-=2)
            yuh = yuh * tlong(1,j);
        yuh = yuh * cnk(kol,2*i);
        ans = ans + yuh;
    }
    ans = ans + tlong(1,1);
    return ans;
}

vector <long long> a;
vector <long long> kol;
vector <bool> vis;

void bfs (int n){
    vis.assign(n,false);
    kol.assign(n+1,0);
    for (int i = 0; i < n; i++){
        if (!vis[i]){
            int k = 1;
            int j = a[i];
            while (j != i){
                vis[j] = true;
                k++;
                j = a[j];
            }
            kol[k]++;
        }
    }
}

FilkinMaksim {
    fast;
    file("sleep2");
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i], a[i]--;
    bfs(n);
    for (int i = 2; i <= n; i+=2)
        if (kol[i] % 2 == 1)
            return cout << 0 << endl, 0;
    tlong ans;
    ans.push_back(1);
    for (long long i = 1; i <= n; i++){
        if (i % 2 == 0) ans = ans * fac(kol[i],i);
        else ans = ans * fac1(kol[i],i);
    }
    write(ans);
}
