/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
int m, n;
vector<int> groupN, groupM;
vector< vector< vector< vector<int> > > > matrix;


void readData(){
    freopen("game.in", "r", stdin);

    scanf("%d%d", &m, &n);
    groupN=vector<int>(n);
    groupM=vector<int>(m);
    for(int i=0; i<m; i++) scanf("%d", &groupM[i]);
    for(int i=0; i<n; i++) scanf("%d", &groupN[i]);
    matrix.assign(n, vector< vector< vector<int> > > (n, vector< vector<int> > (m, vector<int>(m, -1) )));

    fclose(stdin);
}

void solve(int n1, int n2, int m1, int m2){
    vector<bool> used(max(n,m), false);
    int code1, code2;
    for(int i=n1; i<=n2; i++){
        for(int z=m1; z<=m2; z++){
            if(groupN[i]!=groupM[z]) continue;

            if(i==n1 || z==m1){
                code1=0;
            } else {
                if(matrix[n1][i-1][m1][z-1]==-1){
                    solve(n1, i-1, m1, z-1);
                }
                code1=matrix[n1][i-1][m1][z-1];
            }

            if(i==n2 || z==m2){
                code2=0;
            } else {
                if(matrix[i+1][n2][z+1][m2]==-1){
                    solve(i+1, n2, z+1, m2);
                }
                code2=matrix[i+1][n2][z+1][m2];
            }
            used[code1^code2]=true;
        }
    }
    int i=0;
    while(used[i]) i++;
    matrix[n1][n2][m1][m2]=i;
}

void fileOut(){
    freopen("game.out", "w", stdout);

    int code1, code2;
    if( m==0 || n==0 || matrix[0][n-1][0][m-1]==0){
        printf("LOSE\n");
    } else {
        printf("WIN\n");
        for(int i=0; i<m; i++){
            for(int z=0; z<n; z++){
                if(groupN[z]!=groupM[i]) continue;

                if(i==0 || z==0){
                    code1=0;
                } else {
                    code1=matrix[0][z-1][0][i-1];
                }

                if(i==m-1 || z==n-1){
                    code2=0;
                } else {
                    code2=matrix[z+1][n-1][i+1][m-1];
                }
                if( code1^code2 == 0 ) printf("%d %d\n", i, z);
            }
        }
    }

    fclose(stdout);
}

int main(){
    readData();
    if(m!=0 && n!=0) solve(0, n-1, 0, m-1);
    fileOut();
    return 0;
}
