/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
int n;
vector<int> in, cycles;
bool noSol=false;

int base=1e9;
typedef vector<int> big;
big ans;
#define num(a) big(1, (a))
void print(big a){
    printf("%d", a.back());
    for(int i=(int)a.size()-2; i>=0; i--){
        printf("%09d", a[i]);
    }
}
inline big operator + (big a, big b){
    int carry=0;
    for(int i=0; i<max(a.size(), b.size()) || carry; i++){
        if(i==a.size()) a.push_back(0);
        a[i]+=carry;
        a[i]+= i<b.size() ? b[i] : 0;
        carry=a[i]/base;
        a[i]%=base;
    }
    while(a.size()>1 && a.back()==0) a.pop_back();
    return a;
}
inline big operator * (big a, big b){
    big c(a.size()+b.size(), 0);
    long long curr;
    for(int i=0; i<a.size(); i++){
        for(int z=0, carry=0; carry || z<b.size(); z++){
            curr=0LL+carry+1LL*a[i]*(z<b.size() ? b[z] : 0);
            carry=curr/base;
            c[i+z]+=curr%base;
        }
    }
    while(c.size()>1 && c.back()==0) c.pop_back();
    return c;
}
inline bool operator == (big a, int b){
    return (a.size()==1 && a[0]==b);
}
big pow(int a, int b){
    if(b==0) return num(1);
    if(b%2==0){
        big c=pow(a, b/2);
        return c*c;
    } else {
        return num(a)*pow(a, b-1);
    }
}
big doubleFact(int a){
    big res=num(1);
    for(int i=3; i<=a; i+=2){
        res=res*num(i);
    }
    return res;
}


vector<vector<big> > Cnk(101, vector<big>(101, num(0)));
big C(int n, int k){
    if(Cnk[n][k]==0){
        if(n==k || k==0){
            Cnk[n][k]=num(1);
        } else {
            Cnk[n][k]=C(n-1,k-1)+C(n-1,k);
        }
    }
    return Cnk[n][k];
}

void readData(){
    freopen("sleep2.in", "r", stdin);

    scanf("%d", &n);
    in=vector<int>(n);
    cycles=vector<int>(n+1, 0);
    for(int i=0; i<n; i++) {
        scanf("%d", &in[i]);
        in[i]--;
    }

    fclose(stdin);
}

void findCycles(){
    vector<bool> used(n, false);
    int curr, k;
    for(int i=0; i<n; i++){
        if(used[i]) continue;
        used[i]=true;
        curr=1;
        k=in[i];
        while(k!=i){
            curr++;
            used[k]=true;
            k=in[k];
        }
        cycles[curr]++;
    }
}

void checkIfAnswerExists(){
    for(int i=2; i<=n; i+=2){
        if(cycles[i]%2!=0) {
            noSol=true;
            return;
        }
    }
}

void solve(){
    big amount;
    ans=num(1);
    for(int pos=1; pos<=n; pos++){
        if(cycles[pos]==0) continue;
        if(pos%2==0)
            amount=pow(pos, cycles[pos]/2)*doubleFact(cycles[pos]-1);
        else {
            amount=num(1);
            for(int i=1; i<=cycles[pos]/2; i++)
                amount=amount + ( C(cycles[pos], 2*i)*pow(pos, i)*doubleFact(2*i-1)  );
        }
        ans=ans*amount;
    }
}

void fileOut(){
    freopen("sleep2.out", "w", stdout);

    if(noSol){
        printf("0\n");
    } else {
        print(ans);
        printf("\n");
    }

    fclose(stdout);
}

int main(){
    readData();
    findCycles();
    checkIfAnswerExists();
    if( !noSol ) solve();
    fileOut();
    return 0;
}
