#include <bits/stdc++.h>

using namespace std;

typedef vector<int> big;
typedef long long ll;

const int base = 1000000;

big operator*(big a, big b) {
    big ans = big(a.size() + b.size());
    ll hV = 0;
    for(int i = 0;i < a.size();++i) {
        for(int j = 0;j < b.size() || hV;++j) {
            hV = ans[i+j] + hV + a[i] * 1ll * (j < b.size() ? b[j] : 0);
            ans[i+j] = hV % base;
            hV /= base;
        }
    }
    while(ans.size() > 1 && ans.back() == 0) ans.pop_back();
    return ans;
}

big operator + (big a, big b) {
    big ans;
    int hV = 0;
    for(int i = 0;i < b.size() || hV || i < a.size();++i) {
        hV = hV + (i < a.size() ? a[i] : 0) + (i < b.size() ? b[i] : 0);
        ans.push_back(hV % base);
        hV /= base;
    }
    while(ans.size() > 1 && ans.back() == 0) ans.pop_back();
    return ans;
}

int perm[102], n;
int CicleCount[102] = {0};
bool used[102] = {0};

void CalcNumCicle() {
    for(int i = 0;i < n;++i) {
        int k = i, s = 0;
        while(!used[k]) {
            used[k] = 1;
            k = perm[k];
            ++s;
        }
        CicleCount[s]++;
    }
}

big binpow(big a, int b) {
    big ans = big(1, 1);
    while(b) {
        if(b & 1)
            ans = ans * a;
        a = a * a;
        b >>= 1;
    }
    return ans;
}

big cnk[102][102];
big fnn[102];

big& c(int k, int n) {
    if(cnk[k][n].empty()) {
        if(n == k || k == 0)
            cnk[k][n] = big(1, 1);
        else
            cnk[k][n] = c(k - 1, n - 1) + c(k, n - 1);
    }
    return cnk[k][n];
}

big f(int n) {
    n >>= 1;
    if(fnn[n].empty())
        fnn[n] = f(n-1) * big(1, (2*n + 1));
    return fnn[n];
}

int main()
{
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);

    cin >> n;
    for(int i = 0;i < n;++i) {
        cin >> perm[i];
        perm[i]--;
    }

    CalcNumCicle();

    for(int i = 2;i <= n;i+=2)
        if(CicleCount[i] & 1) {
            printf("0\n");
            return 0;
        }

    fnn[0] = big(1, 1);
    big ans = big(1, 1);
    for(int i = 1;i <= n;++i) {
        if(CicleCount[i] == 0)
            continue;
        if(i & 1) {
            big hV = big(1, 0);
            for(int j = 1;j <= CicleCount[i]/2;++j)
                hV = hV + binpow(big(1, i), j) * c(2*j, CicleCount[i]) * f(2*j - 1);
            hV = hV + big(1, 1);
            ans = ans * hV;
        }
        else
            ans = ans * binpow(big(1, i), CicleCount[i]/2) * f(CicleCount[i]-1);
    }

    printf("%d", ans.back());
    for(int i = ans.size()-2;i >= 0;--i)
        printf("%06d", ans[i]);
    printf("\n");
    return 0;
}
