/* GCC */
#include <bits/stdc++.h>
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)


using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
typedef vector<int> Big;
const lint base = 1000*1000*1000;

int perm[101], cycles[101] = {0};
bool used[101] = {0};

Big operator+(const Big& a, const Big& b) {
    Big res = a;
    for (int i = 0, carry = 0; i < max(res.size(), b.size()) || carry; i++) {
        if (i == res.size()) res.push_back(0);
        lint cur = (lint)carry + res[i] + (i < b.size() ? b[i] : 0);
        res[i] = cur % base;
        carry = cur / base;
    }
    return res;
}

Big operator*(const Big& a, const Big& b) {
    Big res(a.size() + b.size(), 0);
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0, carry = 0; j < b.size() || carry; j++) {
            lint cur = (lint)a[i]*(j < b.size() ? b[j] : 0) + res[i+j] + carry;
            res[i+j] = cur % base;
            carry = cur / base;
        }
    }
    while (res.size() && res.back() == 0)
        res.pop_back();
    return res;
}

Big binpow(int a_, int p) {
    Big a(1, a_), res(1, 1);
    while (p) {
        if (p & 1) res = res*a;
        a = a*a;
        p >>= 1;
    }
    return res;
}

Big cnk[101][101];
Big nff[101];
Big ans(1, 1);

Big& c(int n, int k) {
    if (!cnk[n][k].empty()) return cnk[n][k];
    if (n == k || k == 0) return cnk[n][k] = Big(1, 1);
    return cnk[n][k] = c(n-1, k-1) + c(n-1, k);
}

Big& ff(int n) { /// for odds
    if (!nff[n].empty()) return nff[n];
    if (n == 1) return nff[n] = Big(1, 1);
    return nff[n] = Big(1, n)*ff(n-2);
}

void print(const Big& a) {
    printf("%d", a.empty() ? 0 : a.back());
    for (int i = (int)a.size()-2; i >= 0; i--)
        printf("%09d", a[i]);
    printf("\n");
}

void trace(int i) {
    int start = i, len = 0;
    do {
        used[i] = 1;
        i = perm[i];
        len++;
    } while (i != start);
    cycles[len]++;
}

int main() {

    files(sleep2);

    int n;
    scanf("%d", &n);

    for (int i = 1; i <= n; i++)
        scanf("%d", perm+i);

    for (int i = 1; i <= n; i++)
        if (!used[i]) trace(i);

    for (int i = 2; i <= n; i += 2)
        if (cycles[i] % 2 == 1) {
            printf("0\n");
            return 0;
        }

    for (int t = 1; t <= n; t++) {
        if (cycles[t] == 0) continue;
        Big a(1, 1);
        if (t % 2 == 0) {
            a = binpow(t, cycles[t]/2)*ff(cycles[t]-1);
        } else {
            for (int i = 1; i <= cycles[t]/2; i++)
                a = a + c(cycles[t], 2*i)*binpow(t, i)*ff(2*i-1);
        }
        ans = ans * a;
    }

    print(ans);

    return 0;
}
